#ifndef __ASFHEADER_H__
#define __ASFHEADER_H__

#include <inttypes.h>

struct BITMAPINFOHEADER
{
	int biSize;
	int biWidth;
	int biHeight;
	short biPlanes;
	short biBitCount;
	int biCompression;
	int biSizeImage;
	int biXPelsPerMeter;
	int biYPelsPerMeter;
	int biClrUsed;
	int biClrImportant;
};

struct WAVEFORMAT
{
	short wFormatTag;
	short nChannels;
	int nSamplesPerSec;
	int nAvgBytesPerSec;
	short nBlockAlign;
	short wBitsPerSample;
};

#ifdef __cplusplus
extern "C" {
#endif

extern struct BITMAPINFOHEADER *vidheader;
extern struct WAVEFORMAT *audheader;

#define MAX_BUFSIZE 1*1024*1024
extern char vidbuf[MAX_BUFSIZE];
extern char audbuf[MAX_BUFSIZE];
extern int vidbufsize;
extern int audbufsize;
extern int iskeyframe;
extern int vidtime;

extern char *audextdata;
extern int audextsize;
extern char *vidextdata;
extern int vidextsize;

extern uint16_t title[1024];
extern uint16_t author[1024];
extern int playtime;

int asfOpen(const char *name);
int asfRead();
void asfClose();
void asfVideoOff();

#ifdef __cplusplus
};
#endif

#endif // __ASFHEADER_H__
