#ifdef GP2X
//[*]----------------------------------------------------------------------------------------------------[*]
// Scale-Down -> Screen Shake  [ use path : FDC -> 1D-MEM -> MLC -> DPC ]
//[*]----------------------------------------------------------------------------------------------------[*]
#include "mmsp2_if.h"
#include "asfheader.h"
//[*]----------------------------------------------------------------------------------------------------[*]
// device open & close
int memfd 		= 0;      	// /dev/mem fd
int mp4_fd 		= 0;		// dualcpu driver fd
int vpp_fd 		= 0;     	// vpp driver fd
int	cx_fd 		= 0;		// cx25874 driver fd
int init_flag 	= 0;  		// arm940 setup init flag 
static int frame_decode_count;  // hhsong add.. when fill 3 frames because of three swap buffer, YUVA layer on...
//[*]----------------------------------------------------------------------------------------------------[*]
// arm 940 interface structure
static MP4D_INIT_PARAM 		mp4d_init;   	// 940 init for mpeg4 decoder(aka divx)
static MP4D_INIT_BUF_PARAM 	mp4d_init_buf;  // setup 940 interface 2D memory
static MP4D_RUN_PARAM 		mp4d_run; 		// 940 video decode run command
static MP4D_REL_PARAM 		mp4d_rel; 		// release 940 mpeg4 decoder setting
static WMVD_INIT_PARAM 		wmvd_init;   	// 940 init for mpeg4 decoder(aka divx)
static WMVD_RUN_PARAM 		wmvd_run; 		// 940 video decode run command
static WMVD_REL_PARAM 		wmvd_rel; 		// release 940 mpeg4 decoder setting
//[*]----------------------------------------------------------------------------------------------------[*]
// arm 940 interface memory ptr
void *arm940_mem_start = NULL;    // 940 decode interfacing memory, 0x0200_0000(32M start)
//[*]----------------------------------------------------------------------------------------------------[*]
static unsigned char *rl_buf = NULL;   	// run length decoding buffer
static unsigned char *out_addr = NULL;
// decode data  buffer
unsigned short y_offset[6];
unsigned short cb_offset[6];
unsigned short cr_offset[6];
unsigned int decode_frame;
unsigned int display_frame;
unsigned int dbuf_ptr[0x100];
//[*]----------------------------------------------------------------------------------------------------[*]
// extern variable
unsigned char  *dbuf;           // compressed frame data buffer,  迭, ring q  ʴ´. 20050225  
int dbufsize;
MP4D_DISPLAY_PARAM mp4d_disp;   // get status 940 register & decode output variable
//[*]----------------------------------------------------------------------------------------------------[*]
// FDC, MLC control structure
static FDC_INFO fdc_info;
static YUV_INFO yuv_info;
static SC_INFO 	sc_info;
//[*]----------------------------------------------------------------------------------------------------[*]
// fourcc macro: little endian  ̷ ǰ, big endian   ٲߵȴ.
#ifndef mmioFOURCC
#define mmioFOURCC( ch0, ch1, ch2, ch3 )                \
	( (unsigned int)(char)(ch0) | ( (unsigned int)(char)(ch1) << 8 ) |  \
	( (unsigned int)(char)(ch2) << 16 ) | ( (unsigned int)(char)(ch3) << 24 ) )
#endif

#define CODEC_INFO_SIZE 14
// fourcc  dualcpu.h ִ define codec ˻ϱ  .
struct codec_type_t {
    unsigned int    format;
    short           number;
} CodecInfo[CODEC_INFO_SIZE] = 
{
    {mmioFOURCC('w', 'm', 'v', '1'), CODEC_VER_WMV_7},
    {mmioFOURCC('W', 'M', 'V', '1'), CODEC_VER_WMV_7},
    {mmioFOURCC('w', 'm', 'v', '7'), CODEC_VER_WMV_7},
    {mmioFOURCC('W', 'M', 'V', '7'), CODEC_VER_WMV_7},
    {mmioFOURCC('w', 'm', 'v', '2'), CODEC_VER_WMV_8},
    {mmioFOURCC('W', 'M', 'V', '2'), CODEC_VER_WMV_8},
    {mmioFOURCC('w', 'm', 'v', '8'), CODEC_VER_WMV_8},
    {mmioFOURCC('W', 'M', 'V', '8'), CODEC_VER_WMV_8},
    {mmioFOURCC('w', 'm', 'v', '3'), CODEC_VER_WMV_9},
    {mmioFOURCC('W', 'M', 'V', '3'), CODEC_VER_WMV_9},
    {mmioFOURCC('w', 'm', 'v', '9'), CODEC_VER_WMV_9},
    {mmioFOURCC('W', 'M', 'V', '9'), CODEC_VER_WMV_9},
    {mmioFOURCC('m', 'p', '4', '3'), CODEC_VER_DIVX_311},
    {mmioFOURCC('M', 'P', '4', '3'), CODEC_VER_DIVX_311},
};
//[*]----------------------------------------------------------------------------------------------------[*]
/*
 * function call procedure
 *
 * mmsp2_940_interface_buffer_init()
 * open_dualcpu_vpp()
 * mmsp2_setup_940_interface_buffer()
 * ...
 *
 */
//[*]----------------------------------------------------------------------------------------------------[*]
int mmsp2_940_interface_buffer_init(void)
{
    unsigned char  *addr;

    // /dev/mem ϱ  open
    memfd = open("/dev/mem", O_RDWR | O_SYNC);
    if (memfd < 0) {
        printf("open /dev/mem failed\n");
        return -1;
    }

    // 0x0200_0000  arm940_mem_start mapping
    // start, length(0x0100_0000 = 16M, protect option, type of the mapped object, fd, mappingϰ ϴ  ޸ start address
    arm940_mem_start = mmap(0, 0x01000000, PROT_READ | PROT_WRITE, MAP_SHARED, memfd, CODEC_BUFF_ADDR);
    if (arm940_mem_start == NULL) {
        printf("/dev/mem mmap() failed\n");
        return -1;
    }

    dbuf = (unsigned char *)arm940_mem_start;
    out_addr = (unsigned char *)arm940_mem_start + 0x00200000;
    rl_buf = (unsigned char *)arm940_mem_start + 0x00280000;

    y_offset[0] = 0x0240;
    cb_offset[0] = 0x0244;
    cr_offset[0] = 0x0246;
    y_offset[1] = 0x0260;
    cb_offset[1] = 0x0264;
    cr_offset[1] = 0x0266;
    y_offset[2] = 0x0280;
    cb_offset[2] = 0x0284;
    cr_offset[2] = 0x0286;
    y_offset[3] = 0x02A0;
    cb_offset[3] = 0x02A4;
    cr_offset[3] = 0x02A6;
    y_offset[4] = 0x02C0;
    cb_offset[4] = 0x02C6;
    cr_offset[4] = 0x02C8;

    y_offset[5] = 0x0248;
    cb_offset[5] = 0x024C;
    cr_offset[5] = 0x024E;

    addr = (unsigned char *)arm940_mem_start + 0x00400000;
    memset(addr, 0x10, 0x200000);
    addr = (unsigned char *)arm940_mem_start;
    memset(addr, 0, 0x200000);

    return 1;
}                               // mmsp2_940_buf_initsetup
//[*]----------------------------------------------------------------------------------------------------[*]
// main vformat_fourcc ãƼ format ǳָ Լ ؼ ã ƾ  
// vformat_fourcc mmioFOURCC( compressor[0], compressor[1], compressor[2], compressor[3])ؼ Է  
int mmsp2_setup_940_interface_buffer(int width, int height, unsigned int vformat_fourcc)
{
    int             j;
    unsigned int    rlbuf_ptr;
    unsigned long	bufaddr;
    int				codec;

    if ((width > MAX_WIDTH) || (height > MAX_HEIGHT))
    {
        printf("width and height are not supported\n");
        goto quit;
    }

    for (j = 0; j < CODEC_INFO_SIZE; j++)
    {
        if (CodecInfo[j].format == vformat_fourcc)
        {
            printf("codec found = %d\n", j);
            break;
        }
    }

    if(j == CODEC_INFO_SIZE)
    {
        printf("AVI compressor(fourcc) is not supported in current mmsp2 firmware!\n");
        goto quit;
    }
    
    if(CodecInfo[j].number != CODEC_VER_DIVX_311) {
	    wmvd_init.Command 	= MP_CMD_INIT;
	    wmvd_init.CodecType = MP_CODEC_WMVD;
	    wmvd_init.Width 	= width;
	    wmvd_init.Height 	= height;
	    
	    /*if(width > 640) {
	        printf("width are not supported in wmv codec\n");
	        goto quit;
		}*/
	
	    // codec type Էµ format  ̹ ǵ ѿ fourcc  ã´.
	    wmvd_init.CodecVersion = CodecInfo[j].number;
	
		memcpy(dbuf, vidextdata, vidextsize);
	    bufaddr = (unsigned long)dbuf - (unsigned long) arm940_mem_start + CODEC_BUFF_ADDR;
	    wmvd_init.StreamBufferPaddr = bufaddr;
	    wmvd_init.StreamLength = vidextsize;
	
	    printf("WMVD Codec Version: %d\n", wmvd_init.CodecVersion);
	    printf("WMVD Extra Codec Informaition: %d bytes\n", wmvd_init.StreamLength);
	
		for(j=0; j < 10; j++) {
			if(write(mp4_fd, &wmvd_init, sizeof(wmvd_init)) > 0)
				break;
	
			printf("reopen dualcpu...\n");
			usleep(300000); // wait 0.3 sec.
	
			close(mp4_fd);
			mp4_fd = open(PATH_DEV_DUALCPU, O_RDWR);
			if (mp4_fd < 0) {
				mp4_fd = open(PATH_DEV_DUALCPU_WITH_DEVFS, O_RDWR);
				if (mp4_fd < 0) {
					printf("IOCTL_DUALCPU_WMVD_INIT failed\n");
					goto quit;
				}
			}
		}
	
		if(j == 10) {
			printf("IOCTL_DUALCPU_WMVD_INIT failed\n");
			goto quit;
		}
	
	    if(read_mp4d_940_status(&mp4d_disp)<0) {
	        printf("MP_CMD_INIT failed => goto quit\n");
	        goto quit;
	    }
	    
	    // 940 engine init
	    init_flag = 1;
	    decode_frame = 0;
	    display_frame = 0;
	
	    return wmvd_init.CodecVersion - CODEC_VER_WMV_7 + 7;
	} else {
	    mp4d_init.Command 	= MP_CMD_INIT;
	    mp4d_init.CodecType = MP_CODEC_MP4D;
	    mp4d_init.Width 	= width;
	    mp4d_init.Height 	= height;

	    mp4d_init.CodecVersion = CODEC_VER_DIVX_311;
        mp4d_init.CodecType = MP_CODEC_MP4D_DIVX3;

	    mp4d_init.non_bframe_max = 4;
	    mp4d_init.b_frame_max = 2;

	    rlbuf_ptr = (unsigned long) rl_buf - (unsigned long) arm940_mem_start + CODEC_BUFF_ADDR;

	    mp4d_init.RL_L = (unsigned short) (rlbuf_ptr & 0x0000FFFF);
	    mp4d_init.RL_H = (unsigned short) (rlbuf_ptr >> 16);
	    mp4d_init.RL_Length = 512;
	
	    mp4d_init.mbp_a_addr_offset = 0x02F0;
	    mp4d_init.mbp_b_addr_offset = 0x02E0;
	    mp4d_init.qmat_addr_h = 0x0220;
	    mp4d_init.qmat_addr_l = 0x0000;
	    mp4d_init.pred_q_lb_offset = 0x0230;
	    mp4d_init.arm940_offset = 0x0300;

		for(j=0; j < 10; j++) {
			if(ioctl(mp4_fd, IOCTL_DUALCPU_MP4D_INIT, &mp4d_init) == 1)
				break;
	
			printf("reopen dualcpu...\n");
			usleep(300000); // wait 0.3 sec.

			close(mp4_fd);
			mp4_fd = open(PATH_DEV_DUALCPU, O_RDWR);
			if (mp4_fd < 0) {
				mp4_fd = open(PATH_DEV_DUALCPU_WITH_DEVFS, O_RDWR);
				if (mp4_fd < 0) {
					printf("IOCTL_DUALCPU_MP4D_INIT failed\n");
					goto quit;
				}
			}
		}
	
		if(j == 10) {
			printf("IOCTL_DUALCPU_MP4D_INIT failed\n");
			goto quit;
		}
	
	    if(read_mp4d_940_status(&mp4d_disp)<0)
	    {
	        printf("MP_CMD_INIT failed => goto quit\n");
	        goto quit;
	    }

	    for (j = 0; j < 6; j++)
	    {
	        mp4d_init_buf.Command = MP_CMD_INIT_BUF;
	        mp4d_init_buf.BufferType = ((j < 4) ? 1 : 0);
	        mp4d_init_buf.BufferIdx = ((j < 4) ? j : (j - 4));
	        mp4d_init_buf.Y_Offset = y_offset[j];
	        mp4d_init_buf.CB_Offset = cb_offset[j];
	        mp4d_init_buf.CR_Offset = cr_offset[j];

	        if (ioctl(mp4_fd, IOCTL_DUALCPU_MP4D_INIT_BUF, &mp4d_init_buf) != 1)
	        {
	            printf("IOCTL_DUALCPU_MP4D_INIT_BUF failed\n");
	            goto quit;
	        }

	        if (read_mp4d_940_status(&mp4d_disp) < 0)
	        {
	            printf("IOCTL_DUALCPU_MP4D_INIT_BUF timeout\n");
	            goto quit;
	        }
	    }
	
	    init_flag = 2;
	    decode_frame = 0;
	    display_frame = 0;
	
	    return 43;
	}

quit:

    return -1;
}
//[*]----------------------------------------------------------------------------------------------------[*]
int open_dualcpu_vpp(void)
{
	int retry = 1;

	while(retry) {
		// devfs Ѵ. dualcpu misc driver openѴ.
		mp4_fd = open(PATH_DEV_DUALCPU, O_RDWR);
		if (mp4_fd >= 0) break;

		mp4_fd = open(PATH_DEV_DUALCPU_WITH_DEVFS, O_RDWR);
		if (mp4_fd >= 0) break;

		if(retry) {
			// dualcpu  ߰Ѵ.
			printf("insert dualcpu module...\n");
			system("/sbin/insmod dualcpu.o");
			retry = 0;
		} else {
			printf("open dualcpu driver failed\n");
			return -1;
		}
	}
/*	
	system("rmmod dualcpu");
	system("rmmod dualcpu_wmv");
	mp4_fd = -1;
*/
    vpp_fd = open(PATH_DEV_VPP, O_RDWR);
    if (vpp_fd < 0)
    {
        vpp_fd = open(PATH_DEV_VPP_WITH_DEVFS, O_RDWR);
        if (vpp_fd < 0)
        {
            printf("open video post processor driver failed\n");
            return -1;
        }
    }

	if((ioctl(vpp_fd, IOCTL_MMSP2_DPC_VSYNC_INTERRUPT_ENABLE ,NULL))<0)	// hhsong add for vsync interrupt
	{
		close(vpp_fd);
		vpp_fd = -1;
		return -1;
	}

    return 1;
}
//[*]----------------------------------------------------------------------------------------------------[*]
void mmsp2_release_codec(void)
{
    int i;

    if (init_flag == 1) {
        wmvd_rel.Command = MP_CMD_RELEASE;
		wmvd_rel.CodecType = MP_CODEC_WMVD;

        i = 1000;
        do
        {
			if (write(mp4_fd, &wmvd_rel, sizeof(wmvd_rel)) > 0)
				break;
            usleep(10000);
            i--;
        }
        while (i > 0);

        if(i == 0)         // release fail  ׳ failó ϰ .
        {
            printf("IOCTL_DUALCPU_WMVD_RELEASE failed\n");
        }
        else                // fail ƴ  status д´.
        {
            if (read_mp4d_940_status(&mp4d_disp) < 0)
            {
                printf("IOCTL_DUALCPU_WMVD_RELEASE timeout\n");
            }
        }
	} else if (init_flag == 2) {
        mp4d_rel.Command = MP_CMD_RELEASE;

	    if (mp4d_init.CodecVersion == CODEC_VER_DIVX_311)
			mp4d_rel.CodecType = MP_CODEC_MP4D_DIVX3;
	    else
			mp4d_rel.CodecType = MP_CODEC_MP4D;

        i = 1000;
        do
        {
            if (ioctl(mp4_fd, IOCTL_DUALCPU_MP4D_RELEASE, &mp4d_rel) == 1)
                break;
            usleep(10000);
            i--;
        }
        while (i > 0);

        if(i == 0)         // release fail  ׳ failó ϰ .
        {
            printf("IOCTL_DUALCPU_MP4D_RELEASE failed\n");
        }
        else                // fail ƴ  status д´.
        {
            if (read_mp4d_940_status(&mp4d_disp) < 0)
            {
                printf("IOCTL_DUALCPU_MP4D_RELEASE timeout\n");
            }
        }
	}
	init_flag = 0;
}
//[*]----------------------------------------------------------------------------------------------------[*]

void close_dualcpu_vpp_unmap(void)
{
    if (mp4_fd >= 0) {
		mmsp2_release_codec();
        close(mp4_fd);
    }

    // YUVB off & RGB on
    if (vpp_fd >= 0)
    {		
		ioctl(vpp_fd, IOCTL_MMSP2_STOP_SC, NULL);
        ioctl(vpp_fd, IOCTL_MMSP2_YUVA_OFF, NULL);
		ioctl(vpp_fd, IOCTL_MMSP2_RGB_OFF, 1);
        ioctl(vpp_fd, IOCTL_MMSP2_RGB_ON, 0);
		ioctl(vpp_fd, IOCTL_MMSP2_DPC_VSYNC_INTERRUPT_DISABLE ,NULL); // hhsong add for vsync interrupt
	
        close(vpp_fd);
    }
	
    if (arm940_mem_start)
        munmap(arm940_mem_start, 0x01000000);

    if (memfd >= 0)
        close(memfd);
}
//[*]----------------------------------------------------------------------------------------------------[*]
int read_mp4d_940_status(MP4D_DISPLAY_PARAM * mp4d_940)
{
    if(read(mp4_fd, (void *)mp4d_940, sizeof(MP4D_DISPLAY_PARAM)) <= 0)
    {
        printf("dualcpu read error");
        return -1;
    }

    return 0;
}
//[*]----------------------------------------------------------------------------------------------------[*]
int set_FDC_YUVB_plane(int width, int height)
{
	unsigned int cal_width  = width;
	unsigned int cal_height = height;
	float ratio1=1.0, ratio2=1.0, cal_ratio=1.0;
    unsigned long bufaddr;

	frame_decode_count = 0;

	ratio1 = (float)width / (float)LCD_WIDTH;	
	ratio2 = (float)height/ (float)LCD_HEIGHT;

	cal_ratio = (ratio1 > ratio2) ? ratio1 : ratio2 ;
	printf("cal_ratio = %6f\n",cal_ratio);

	printf("width : cal_ratio %f %d, %f\n", width /cal_ratio+0.5,  width, cal_ratio);
	printf("height/cal_ratio  %f %d, %f\n", height/cal_ratio+0.5, height, cal_ratio);

	cal_width  = (unsigned short)(width /cal_ratio+0.5);
	cal_height = (unsigned short)(height/cal_ratio+0.5); // height scaling => green screen && shaking

	printf("cal_width = %d, cal_height = %d \n",cal_width, cal_height);

   	fdc_info.VSync 		= 0;
    fdc_info.SrcField 	= 0;      // Frame
    fdc_info.Chroma 	= FDC_CHROMA_420;
    fdc_info.Rotate 	= FDC_ROT_000;
	
    fdc_info.DstField = 0;      // Frame
    fdc_info.ToScaler = 1;  
	
	fdc_info.Width 	= width;
	fdc_info.Height = height;
	
    fdc_info.Y_Offset 		= y_offset[0];
    fdc_info.CB_Offset 		= cb_offset[0];
    fdc_info.CR_Offset 		= cr_offset[0];
    fdc_info.DstBaseAddr 	= 0;

    //bufaddr = (unsigned long)out_addr - (unsigned long)arm940_mem_start + CODEC_BUFF_ADDR;
    //fdc_info.DstBaseAddr 	= bufaddr;

	ioctl(vpp_fd, IOCTL_MMSP2_SET_FDC, &fdc_info);  // setup FDC
	ioctl(vpp_fd, IOCTL_MMSP2_START_FDC, NULL);// enable FDC

    sc_info.Src = SC_FRM_FDC;

//	sc_info.Dst = SC_TO_MLC;
	sc_info.Dst = SC_TO_MEM;

//	sc_info.NumOfFrame = SC_FOREVER;
	sc_info.NumOfFrame = SC_1_TIME;

    sc_info.WriteForm = SC_YCBYCR;
    sc_info.WriteField = SC_WR_FRAME;
    sc_info.hSrcMirror = SC_MIRROR_OFF;
    sc_info.vSrcMirror = SC_MIRROR_OFF;
    sc_info.hDstMirror = SC_MIRROR_OFF;
    sc_info.vDstMirror = SC_MIRROR_OFF;
    sc_info.SrcOddAddr = 0;
    sc_info.SrcEvenAddr = 0;
	sc_info.DstAddr = 0;
	
	if(init_flag == 1) {
		bufaddr = (unsigned long)out_addr - (unsigned long)arm940_mem_start + CODEC_BUFF_ADDR;
		sc_info.DstAddr = bufaddr;
	} else {
		sc_info.DstAddr = 0x03700000;
	}

    sc_info.Y_Offset = 0;
    sc_info.CB_Offset = 0;
    sc_info.CR_Offset = 0;

	sc_info.SrcWidth	=	width;
	sc_info.SrcHeight	=	height;
	sc_info.SrcStride	=	width*2;
	sc_info.DstWidth	=	cal_width;
	sc_info.DstHeight	=	cal_height;
	sc_info.DstStride	=	cal_width*2;

	ioctl(vpp_fd, IOCTL_MMSP2_SET_SC, &sc_info);
	ioctl(vpp_fd, IOCTL_MMSP2_ENABLE_SC, 1);
	ioctl(vpp_fd, IOCTL_MMSP2_START_SC, SC_STARTMEM);

 	yuv_info.Src = 1;
 	yuv_info.Src = 0;
    yuv_info.Priority 	= MLC_YUV_PRIO_A; // FDC YUVB Ƿ priority ش.
    yuv_info.vMirrorTop = MLC_YUV_MIRROR_OFF;
    yuv_info.hMirrorTop = MLC_YUV_MIRROR_OFF;
    yuv_info.vMirrorBot = MLC_YUV_MIRROR_OFF;
    yuv_info.hMirrorBot = MLC_YUV_MIRROR_OFF;
	
	yuv_info.SrcWidthTop 	= cal_width;
	yuv_info.SrcHeightTop 	= cal_height;
	yuv_info.DstWidthTop 	= cal_width;
	yuv_info.DstHeightTop 	= cal_height;
	yuv_info.StrideTop 		= cal_width*2;	
	
	yuv_info.SrcWidthBot 	= cal_width;
	yuv_info.SrcHeightBot 	= cal_height;
	yuv_info.DstWidthBot 	= cal_width;
	yuv_info.DstHeightBot 	= cal_height;
	yuv_info.StrideBot 		= cal_width*2;	
	
    yuv_info.StartX = (LCD_WIDTH  - cal_width ) / 2;
    yuv_info.StartY = (LCD_HEIGHT - cal_height) / 2; 
		
    yuv_info.EndX = yuv_info.StartX + cal_width;			
    yuv_info.EndY = yuv_info.StartY + cal_height-1; // for TV_out last line green

    printf("yuv_info.StartY :  yuv_info.EndY %d , %d\n", yuv_info.StartY,  yuv_info.EndY);
    yuv_info.BottomY = yuv_info.EndY;

	yuv_info.TopAddr = 0;
	yuv_info.BotAddr = 0;

	if(init_flag == 1) {
		bufaddr = (unsigned long)out_addr - (unsigned long)arm940_mem_start + CODEC_BUFF_ADDR;
		yuv_info.TopAddr = bufaddr;
		yuv_info.BotAddr = bufaddr+(cal_width*2);
	} else {
		yuv_info.TopAddr = 0x03800000;
		yuv_info.BotAddr = 0x03800000;
	}

    ioctl(vpp_fd, IOCTL_MMSP2_SET_YUVA, &yuv_info); // setup MLC YUV layer A

	ioctl(vpp_fd, IOCTL_MMSP2_YUVA_OFF, NULL);  // disable YUV layer A
//	ioctl(vpp_fd, IOCTL_MMSP2_YUVA_ON, NULL);   // enable YUV layer A
	ioctl(vpp_fd, IOCTL_MMSP2_YUVB_OFF, NULL);  // disable YUV layer B

    //ioctl(vpp_fd, IOCTL_MMSP2_RGB_OFF, 0);  // disable RGB layer 0

    return 1;
}
//[*]----------------------------------------------------------------------------------------------------[*]
int run_940_decoder(unsigned long bufaddr, unsigned long bufsize)
{
	if(init_flag == 1) {
		// Setup WMVD data structure and call IOCTL functions of DUALCPU
		wmvd_run.Command = MP_CMD_RUN;
		wmvd_run.CodecType = MP_CODEC_WMVD;

		bufaddr += (unsigned long)dbuf - (unsigned long)arm940_mem_start + CODEC_BUFF_ADDR;
		wmvd_run.StreamBufferPaddr = bufaddr;
		wmvd_run.StreamLength = bufsize;
		wmvd_run.OutputYP2Daddr = y_offset[decode_frame & 3];
		wmvd_run.OutputUP2Daddr = cb_offset[decode_frame & 3];
		wmvd_run.OutputVP2Daddr = cr_offset[decode_frame & 3];
		decode_frame++;
		
		if(write(mp4_fd, &wmvd_run, sizeof(wmvd_run)) <= 0)
		{
			printf("IOCTL_DUALCPU_WMVD_RUN failed\n");
			return -1;
		}
	} else {
		// Setup MP4D data structure and call IOCTL functions of DUALCPU
		mp4d_run.Command = MP_CMD_RUN;

		if(mp4d_init.CodecVersion == CODEC_VER_DIVX_311)
			mp4d_run.CodecType = MP_CODEC_MP4D_DIVX3;
		else
			mp4d_run.CodecType = MP_CODEC_MP4D;

		bufaddr += (unsigned long)dbuf - (unsigned long)arm940_mem_start + CODEC_BUFF_ADDR;
		mp4d_run.StreamBufferPaddrL = (unsigned short) (bufaddr & 0x0000FFFF);
		mp4d_run.StreamBufferPaddrH = (unsigned short) (bufaddr >> 16);

		if(ioctl(mp4_fd, IOCTL_DUALCPU_MP4D_RUN, &mp4d_run) != 1)
		{
			printf("IOCTL_DUALCPU_MP4D_RUN failed\n");
			return -1;
		}
	}
    return 1;
}
//[*]----------------------------------------------------------------------------------------------------[*]
FDC_RUN_INFO fri;
//[*]----------------------------------------------------------------------------------------------------[*]
void run_FDC_and_display()
{
	if(init_flag == 1) {
		fri.Y_Offset  = y_offset[display_frame & 3];
		fri.CB_Offset = cb_offset[display_frame & 3];
		fri.CR_Offset = cr_offset[display_frame & 3];
		display_frame++;

		ioctl(vpp_fd, IOCTL_MMSP2_START_FDC, &fri);

		ioctl(vpp_fd, IOCTL_MMSP2_START_SC, SC_STARTMEM);
		while(ioctl(vpp_fd, IOCTL_MMSP2_SC_BUSY, NULL));

		if(frame_decode_count++ < 4)		// hhsong modify
		{
			if(frame_decode_count == 3)
				ioctl(vpp_fd, IOCTL_MMSP2_YUVA_ON, NULL);   // enable YUV layer A
				// when fill 3 frames because of three swap buffer, YUVA layer on...
		}
	} else {
		if (mp4d_disp.display_frames != 0) {
			fri.Y_Offset  = mp4d_disp.luma_offset_addr;
			fri.CB_Offset = mp4d_disp.cb_offset_addr;
			fri.CR_Offset = mp4d_disp.cr_offset_addr;
			ioctl(vpp_fd, IOCTL_MMSP2_START_FDC, &fri);
			ioctl(vpp_fd, IOCTL_MMSP2_START_SC, SC_STARTMEM);

			while(ioctl(vpp_fd, IOCTL_MMSP2_SC_BUSY, NULL));

			if(frame_decode_count++ < 4)		// hhsong modify
			{
				if(frame_decode_count == 3)
					ioctl(vpp_fd, IOCTL_MMSP2_YUVA_ON, NULL);   // enable YUV layer A
					// when fill 3 frames because of three swap buffer, YUVA layer on...
			}
		}
		if (mp4d_disp.display_frames == 2) {
			fri.Y_Offset  = mp4d_disp.remain_frame_luma_offset_addr;
			fri.CB_Offset = mp4d_disp.remain_frame_cb_offset_addr;
			fri.CR_Offset = mp4d_disp.remain_frame_cr_offset_addr;
			ioctl(vpp_fd, IOCTL_MMSP2_START_FDC, &fri);
			ioctl(vpp_fd, IOCTL_MMSP2_START_SC, SC_STARTMEM);

			while(ioctl(vpp_fd, IOCTL_MMSP2_SC_BUSY, NULL));

			if(frame_decode_count++ < 4)		// hhsong modify
			{
				if(frame_decode_count == 3)
					ioctl(vpp_fd, IOCTL_MMSP2_YUVA_ON, NULL);   // enable YUV layer A
					// when fill 3 frames because of three swap buffer, YUVA layer on...
			}
		}
	}
}
//[*]----------------------------------------------------------------------------------------------------[*]
#endif // GP2X
